SETTING_RELATIVE_MOVEMENT = "savegame.mod.telekinesis.relative_movement"
SETTING_REMOVE_UNBREAKABLE_ON_DISMOUNT = "savegame.mod.telekinesis.remove_unbreakable"
SETTING_CAMERA_KEEP_OBJECT_VISIBLE_BEHIND_WALLS = "savegame.mod.telekinesis.camera_raytrace"

if not HasKey(SETTING_CAMERA_KEEP_OBJECT_VISIBLE_BEHIND_WALLS) then
	SetBool(SETTING_CAMERA_KEEP_OBJECT_VISIBLE_BEHIND_WALLS, true)
	camera_raytrace = true
end

relative_movement = GetBool(SETTING_RELATIVE_MOVEMENT)
remove_unbreakable = GetBool(SETTING_REMOVE_UNBREAKABLE_ON_DISMOUNT)
camera_raytrace = GetBool(SETTING_CAMERA_KEEP_OBJECT_VISIBLE_BEHIND_WALLS)
rot = 5 + math.random()
if math.random() > 0.999 then rot = rot * 100 end

function drawOpt(text)
	text = text .. ": "
	UiAlign("center middle")
	UiPush()
		UiTranslate(-UiGetTextSize(text) / 2, 0)
		UiText(text)
	UiPop()
	UiColor(1, 1, 1, 1)
	UiTranslate(-300, 0)
	UiTranslate(400)
end

function draw()
	UiTranslate(UiCenter(), 150)
	
	UiFont("regular.ttf", 100)
	UiAlign("center")
	UiText("Telekinesis")
	UiFont("regular.ttf", 40)
	UiPush()
		UiTranslate(UiGetTextSize("Telekinesis"))
		UiColor(1, 1, 0, 1)
		UiScale(2 + math.sin(GetTime() * 5) * 0.2)
		UiRotate(10 + math.sin(GetTime() * 2) * 5)
		UiText("Settings")
	UiPop()
	
	
	UiTranslate(0, 150)
	
	UiFont("regular.ttf", 25)
	
	UiPush()
		drawOpt("Relative movement")
		UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
		if UiTextButton(relative_movement and "Enabled" or "Disabled", 140, 35) then
			relative_movement = not relative_movement
		end
		
	UiPop()
	UiTranslate(0, 50)
	
	UiPush()
		drawOpt("Remove unbreakable on dismount")
		UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
		if UiTextButton(remove_unbreakable and "Enabled" or "Disabled", 140, 35) then
			remove_unbreakable = not remove_unbreakable
		end
		
	UiPop()
	UiTranslate(0, 50)
	
	UiPush()
		drawOpt("Put camera infront of walls to keep object visible")
		UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
		if UiTextButton(camera_raytrace and "Enabled" or "Disabled", 140, 35) then
			camera_raytrace = not camera_raytrace
		end
		
	UiPop()
	
	UiTranslate(0, 100)
	UiAlign("center middle")
	UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
	if UiTextButton("Close", 140, 40) then
		SetBool(SETTING_RELATIVE_MOVEMENT, relative_movement)
		SetBool(SETTING_REMOVE_UNBREAKABLE_ON_DISMOUNT, remove_unbreakable)
		SetBool(SETTING_CAMERA_KEEP_OBJECT_VISIBLE_BEHIND_WALLS, camera_raytrace)
		Menu()
	end	
end